﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace CustomerApp1
{
    public class CmdBuilder
    {
        private List<byte> CurrentData = new List<byte>();

        public CmdBuilder()
        {
        }

        public CmdBuilder(params byte[] data)
        {
            CurrentData.AddRange(data);
        }

        public byte[] Data
        {
            get
            {
                return CurrentData.ToArray();
            }
        }
        public void Push(params byte[] data)
        {
            CurrentData.AddRange(data);
        }

        public void PushUInt16(int value)
        {
            Push(BitConverter.GetBytes((UInt16)value).Reverse().ToArray());
        }

        public void PushInt16(int value)
        {
            Push(BitConverter.GetBytes((Int16)value).Reverse().ToArray());
        }
        public void PushInt32(int value)
        {
            Push(BitConverter.GetBytes((Int32)value).Reverse().ToArray());
        }
        public void PushUInt32(int value)
        {
            Push(BitConverter.GetBytes((UInt32)value).Reverse().ToArray());
        }

        public void PushPoint(Point p)
        {
            PushInt16(p.X);
            PushInt16(p.Y);
        }

        void Clear()
        {
            CurrentData.Clear();
        }

        internal void PushString(string Value)
        {
            Push(System.Text.Encoding.ASCII.GetBytes(Value));
            Push(0);
        }
    }
}
