﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace CustomerApp1
{
    public partial class Form1 : Form
    {
        public Display T;
        private String myStr;
        Random R;
        private int BarGraphWidth = 40;
        private int BarGraphSpacing = 60;
        private int BarGraphPadding = 10;
        private int BottomSpacing = 30;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            R = new Random();
            T = new Display(59);

            //T.TouchEvent = new Display.TouchEventDelegate(ProcessTouch);

            if (T.InitializeDisplay() == false)
            {
                MessageBox.Show("booo");
            }
            
            T.EnableManualUpdate(true);
            T.ClearScreen();

            /*T.Load9Slice(0, "Greenbar.ns");
            //T.Draw9Slice(0, 50, 50, 32, 100);
            T.Load9Slice(1, "Bluebar.ns");
            //T.Draw9Slice(1, 50, 50, 32, 100);*/

            T.ChangeDrawingColor(Color.DarkOliveGreen);
            T.DrawLine(new Point(0, T.Height - BottomSpacing), new Point(T.Width, T.Height - BottomSpacing));

            T.ChangeTouchReportingStyle(11);
            T.SetScrollMode(1); 
            T.SetTextWindow(new Point(0, 260), T.Width, T.Height);

            T.SetTextColor(Color.White);

            for (int i = 0; i < 8; i++)
            {
                T.CreateBarGraph(i, 0, 260, (i * BarGraphSpacing) + BarGraphPadding, 11, BarGraphWidth, 261 - BottomSpacing, Color.Green, Color.FromArgb(18, 18, 55), 0);
                //T.Create9SliceBarGraph(i, 0, 260, (i * BarGraphSpacing) + BarGraphPadding, 11, BarGraphWidth, 261 - BottomSpacing,0,1, 0);
                T.UpdateSingleBargraph(i, 260);
                T.DrawLine(new Point((i * BarGraphSpacing), 261 - BottomSpacing + 11), new Point((i * BarGraphSpacing), 261 + BottomSpacing));
                T.SetTextInsertionPoint(new Point((i * BarGraphSpacing) + (int)(BarGraphWidth / 2) + (int)(BarGraphPadding / 2), 1));
                T.WriteText((i + 1).ToString());

            }
            T.DrawLine(new Point(T.Width - 1, 261 - BottomSpacing + 11), new Point(T.Width - 1, 261 + BottomSpacing));

            /*T.SetTextWindow(new Point(0, 260), T.Width, T.Height);*/
            T.SetTextColor(Color.Blue);
            /*T.SetTextWindow(new Point(0, 250), T.Width, T.Height);*/
            T.ManualUpdate();
            T.EnableManualUpdate(false);
            timer1.Interval = 250;
            timer1.Tick+=new EventHandler(timer1_Tick);
            timer1.Start();

        }

        private void ProcessTouch(string type, int X, int Y)
        {
            myStr = "Type: " + type + "\nX: " + X + "\nY: " + Y;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int[] r = new int[8];
            for (int i = 0; i < 8; i++)
            {
                r[i] = R.Next() % 260;
            }
            T.UpdateMultipleBargraphs(0, r);
            T.Sync();
            label1.Text = myStr;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            T.ClosePort();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
        }
    }
}
